% nakresli model planetky Eros

clear

% otevreni souboru
fid = fopen('sklad/eros_1', 'r');

% nacteni souboru
n_vek = fscanf(fid, '%d', 1); % pocet vektru
n_fac = fscanf(fid, '%d', 1); % pocet trojuhelnicku
% vektory - x,y,z souradnice bodu na povrchu
vek = fscanf(fid, '%f', 3 * n_vek);
vek = reshape(vek, 3, n_vek)';
% velikost vektoru
for i = 1:n_vek
   nr(i) = norm(vek(i,:));
end

% normalizace
vek = vek ./ max(nr);

% indexy vektoru, ktere tvori jednotlive trojuhelniky
fac = fscanf(fid, '%f', 3 * n_fac);
% zvetseni indexu
fac = reshape(fac, 3, n_fac)' + 1;

fclose(fid);

% prehozeni sloupcu kvuli normalam
fac = [fac(:,1) fac(:,3) fac(:,2)];

x = vek(:,1);
y = vek(:,2);
z = vek(:,3);
 
mx = max([max(abs(x)) max(abs(y)) max(max(z))]) / 1.5;

figure(1)
clf

% nakresleni site
trimesh(fac,x,y,z, 'EdgeColor', 'black');
axis equal
axis off
axis([-mx mx -mx mx -mx mx]);
rotate3d on

figure(2)
clf
colormap([0.7 0.7 0.7])

% nakresleni jako povrch
h = trisurf(fac,x,y,z);
% nastaveni parametru, aby to vypadalo pekne
set(h, 'LineStyle', 'none');
set(h, 'FaceLighting', 'gouraud');
set(h, 'FaceColor', 'interp');
set(gcf, 'Color', [0 0 0], 'InvertHardcopy', 'off');
set(h, 'BackFaceLighting', 'lit');
material dull
set(h, 'AmbientStrength', 0);
axis equal
axis off
set(gca, 'CameraViewAngleMode', 'manual');
set(gca, 'CameraViewAngle', 8);

% animace
az = 0;
az_krok = 10;
elev = 30;
phase = 50;
nframes = floor(360 / az_krok);
mov = moviein(nframes);

%while 1
for i = 1:nframes
   [xl, yl, zl] = sph2cart(az / 180 * pi, elev / 180 * pi, 0.1);
   % smer pohledu
   view([xl yl zl]);
   [xl, yl, zl] = sph2cart((az + phase) / 180 * pi, elev / 180 * pi, 1);
   % smer osvetleni
   l = light('Position', [xl yl zl]);
   az = az + az_krok;
   drawnow;
   mov(:,i) = getframe(gcf);
   % vypnuti svetla
   set(l, 'Visible', 'off');
end

% prevedeni na format AVI
movie2avi(mov, 'sklad/Eros');

% prevedeni na format MPG - uzivatelska funkce 'mpgwrite' 
mpgwrite(mov, 'rgb', 'sklad/Eros', 1)

